Package: GraphExperiment
Title: S4 Class for Quantitative Data and Associated Networks
Version: 1.0.1
Date: 2026-03-01
Authors@R: 
    c(
    person(given = "Fabricio",
           family = "Almeida-Silva",
           role = c("aut", "cre"),
           email = "fabricio_almeidasilva@hotmail.com",
           comment = c(ORCID = "0000-0002-5314-2964")),
    person(given = "Yves",
           family = "Van de Peer",
           role = "aut",
           email = "yves.vandepeer@psb.vib-ugent.be",
           comment = c(ORCID = "0000-0003-4327-3730"))
    )
Description: GraphExperiment provides users and developers with an S4 class
    that extends `SingleCellExperiment` by offering infrastructure to
    store and retrieve networks (`igraph` objects) representing how assay 
    features and/or observations are associated with each other. The class was 
    designed to store networks inferred from high-dimensional quantitative 
    data, with feature-feature networks including gene coexpression 
    networks (GCNs), gene regulatory networks (GRNs), and
    co-abundance networks (from proteomics and metabolomics), and
    observation-observation network including cell-cell distances,
    species-species relationships, and sample-sample similarities.
License: GPL-3
URL: https://github.com/almeidasilvaf/GraphExperiment
BugReports: https://support.bioconductor.org/tag/GraphExperiment
Encoding: UTF-8
biocViews: DataRepresentation, DataImport, Infrastructure,
        GeneExpression, Transcriptomics, Network, SingleCell
Depends: SingleCellExperiment, igraph
Imports: methods, SummarizedExperiment, BiocBaseUtils, S4Vectors
Suggests: knitr, BiocStyle, testthat, rmarkdown, covr, sessioninfo
Config/testthat/edition: 3
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/GraphExperiment
git_branch: RELEASE_3_23
git_last_commit: 4494c10
git_last_commit_date: 2026-05-22
Repository: Bioconductor 3.23
Date/Publication: 2026-05-24
NeedsCompilation: no
Packaged: 2026-05-24 22:15:12 UTC; biocbuild
Author: Fabricio Almeida-Silva [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-5314-2964>),
  Yves Van de Peer [aut] (ORCID: <https://orcid.org/0000-0003-4327-3730>)
Maintainer: Fabricio Almeida-Silva <fabricio_almeidasilva@hotmail.com>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# GraphExperiment <img src="man/figures/logo.png" align="right" height="139" alt="" />

<!-- badges: start -->

[![GitHub
issues](https://img.shields.io/github/issues/almeidasilvaf/GraphExperiment)](https://github.com/almeidasilvaf/GraphExperiment/issues)
[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-green.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![check-bioc](https://github.com/almeidasilvaf/GraphExperiment/actions/workflows/rworkflows.devel.yml/badge.svg)](https://github.com/almeidasilvaf/GraphExperiment/actions/workflows/rworkflows.devel.yml)
[![Codecov test
coverage](https://codecov.io/gh/almeidasilvaf/GraphExperiment/graph/badge.svg)](https://app.codecov.io/gh/almeidasilvaf/GraphExperiment)
<!-- badges: end -->

**GraphExperiment** provides users and developers with infrastructure to
store quantitative data from omics assays along with networks
representing how assay features (e.g., genes, proteins, metabolites)
and/or observations (e.g., samples, cells, species) interact with each
other. The `GraphExperiment` S4 class extends `SingleCellExperiment` to
include support for `igraph` objects associated with features (stored in
`rowGraphs`) and observations (stored in `colGraphs`).

The figure belows summarizes the `GraphExperiment` class in comparison
to the `SingleCellExperiment` class.

![](vignettes/GraphExperiment.png)

## Installation instructions

Get the latest stable `R` release from
[CRAN](http://cran.r-project.org/). Then install `GraphExperiment` from
[Bioconductor](http://bioconductor.org/) using the following code:

``` r
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("GraphExperiment")
```

## Citation

Below is the citation output from using `citation('GraphExperiment')` in
R. Please run this yourself to check for any updates on how to cite
**GraphExperiment**.

``` r
print(citation('GraphExperiment'), bibtex = TRUE)
#> To cite package 'GraphExperiment' in publications use:
#> 
#>   Almeida-Silva F, Van de Peer Y (2026). _GraphExperiment: S4 Class for
#>   Quantitative Data and Associated Networks_. R package version 0.99.0,
#>   <https://github.com/almeidasilvaf/GraphExperiment>.
#> 
#> A BibTeX entry for LaTeX users is
#> 
#>   @Manual{,
#>     title = {GraphExperiment: S4 Class for Quantitative Data and Associated Networks},
#>     author = {Fabricio Almeida-Silva and Yves {Van de Peer}},
#>     year = {2026},
#>     note = {R package version 0.99.0},
#>     url = {https://github.com/almeidasilvaf/GraphExperiment},
#>   }
```

## Code of Conduct

Please note that the `GraphExperiment` project is released with a
[Contributor Code of
Conduct](http://bioconductor.org/about/code-of-conduct/). By
contributing to this project, you agree to abide by its terms.

---
output: github_document
---

<!-- README.md is generated from README.Rmd. Please edit that file -->

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.path = "man/figures/README-",
    out.width = "100%"
)
```

# GraphExperiment <img src="man/figures/logo.png" align="right" height="139" alt="" />

<!-- badges: start -->
[![GitHub issues](https://img.shields.io/github/issues/almeidasilvaf/GraphExperiment)](https://github.com/almeidasilvaf/GraphExperiment/issues)
[![Lifecycle: stable](https://img.shields.io/badge/lifecycle-stable-green.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![check-bioc](https://github.com/almeidasilvaf/GraphExperiment/actions/workflows/rworkflows.devel.yml/badge.svg)](https://github.com/almeidasilvaf/GraphExperiment/actions/workflows/rworkflows.devel.yml)
[![Codecov test coverage](https://codecov.io/gh/almeidasilvaf/GraphExperiment/graph/badge.svg)](https://app.codecov.io/gh/almeidasilvaf/GraphExperiment)
<!-- badges: end -->

**GraphExperiment** provides users and developers with infrastructure to
store quantitative data from omics assays along with networks representing
how assay features (e.g., genes, proteins, metabolites) and/or
observations (e.g., samples, cells, species) interact with each other.
The `GraphExperiment` S4 class extends `SingleCellExperiment` to include
support for `igraph` objects associated with features (stored in 
`rowGraphs`) and observations (stored in `colGraphs`).

The figure belows summarizes the `GraphExperiment` class in comparison to
the `SingleCellExperiment` class.

![](vignettes/GraphExperiment.png)

## Installation instructions

Get the latest stable `R` release from [CRAN](http://cran.r-project.org/). Then install `GraphExperiment` from [Bioconductor](http://bioconductor.org/) using the following code:

```{r 'install', eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("GraphExperiment")
```

## Citation

Below is the citation output from using `citation('GraphExperiment')` in R. Please
run this yourself to check for any updates on how to cite __GraphExperiment__.

```{r 'citation', eval = requireNamespace('GraphExperiment')}
print(citation('GraphExperiment'), bibtex = TRUE)
```

## Code of Conduct

Please note that the `GraphExperiment` project is released with a [Contributor Code of Conduct](http://bioconductor.org/about/code-of-conduct/). By contributing to this project, you agree to abide by its terms.

#' @name GraphExperiment-subset
#' 
#' @title Subsetting `GraphExperiment` objects
#' 
#' @aliases [,GraphExperiment,ANY,ANY,ANY-method
#' 
#' @description
#' The subsetting method for \code{\link{GraphExperiment}} objects ensures
#' that nodes from `igraph` objects are filtered to match rows and columns 
#' with the remainder of the object.
#' 
#' @section subset:
#' \describe{
#' \item{\code{[}:}{ subsetting method}
#' }
#' 
#' @param x A \code{\link{GraphExperiment}} object.
#' @param i Numeric, row indices for subsetting.
#' @param j Numeric, column indices for subsetting.
#' 
#' @return a \code{\link{GraphExperiment}} object.
#' 
#' @examples
#' # Simulate elements of a GraphExperiment object
#' ## Assays
#' gene_ids <- paste0("gene", seq_len(200))
#' cell_ids <- paste0("cell", seq_len(100))
#' mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))
#' 
#' ## rowGraph (with node attributes)
#' g <- graph_from_adjacency_matrix(cor(t(mat)), weighted = TRUE)
#' V(g)$degree <- igraph::strength(g)
#' 
#' ## colGraph
#' g2 <- graph_from_adjacency_matrix(cor(mat), weighted = TRUE)
#' 
#' ## rowData
#' rdata <- data.frame(
#'     row.names = gene_ids, 
#'     pathway = sample(c("P1", "P2"), size = length(gene_ids), replace = TRUE),
#'     coding = sample(c(TRUE, FALSE), size = length(gene_ids), replace = TRUE)
#' )
#' 
#' ## colData
#' cdata <- data.frame(
#'     row.names = cell_ids, 
#'     celltype = sample(c("ct1", "ct2"), size = length(cell_ids), replace = TRUE)
#' )
#' 
#' 
#' # Create a GraphExperiment object
#' ge <- GraphExperiment(
#'     assays = list(counts = mat), 
#'     rowData = rdata,
#'     colData = cdata,
#'     rowGraphs = list(cor = g),
#'     colGraphs = list(cellcor = g2)
#' )
#' ge
#' 
#' # Subset object
#' ge[1:5, 1:5]
NULL

#' @importFrom methods callNextMethod
#' @importFrom igraph induced_subgraph
#' @export
setMethod(
    "[", c("GraphExperiment", "ANY", "ANY"),
    function(x, i, j, ..., drop = FALSE) {
        
        if(missing(i)) i <- TRUE
        if(missing(j)) j <- TRUE
        
        rglist <- rowGraphs(x)
        cglist <- colGraphs(x)
        x <- callNextMethod(x, i, j, ..., drop = drop)
        
        ## Rows
        if(length(rglist) > 0 || !isTRUE(i)) {
            keep <- rownames(x)
            rglist <- SimpleList(lapply(rglist, function(g) {
                induced_subgraph(g, vids = keep)
            }))
        }
        
        ## Cols
        if(length(cglist) > 0 || !isTRUE(j)) {
            keep <- colnames(x)
            cglist <- SimpleList(lapply(cglist, function(g) {
                induced_subgraph(g, vids = keep)
            }))
        }
        
        BiocBaseUtils::setSlots(x, rowGraphs = rglist, colGraphs = cglist)
    }
)

#' Methods for `GraphExperiment` objects
#' 
#' The \code{GraphExperiment} class provides users with methods to get and
#' set graphs (\code{igraph} objects) representing how features and observations 
#' of \code{SingleCellExperiment} objects relate to each other.
#'
#' @param x A \code{GraphExperiment} object.
#' @param i List element (numeric for index, character for name) of the element
#' to access or replace.
#' @param value Replacement value for replacement methods.
#' @param ... Ignored.
#' @return Return values depend on the method. See details and examples.
#' 
#' @section rowGraphs/colGraphs and rowGraph/colGraph methods:
#' \describe{
#'   \item{\code{rowGraphs(x)} and \code{colGraphs(x)}: }{
#'     Getter for a \code{SimpleList} of \code{igraph} objects representing 
#'     rows and columns, respectively.}
#'   \item{\code{rowGraphs(x) <- value} and \code{colGraphs(x) <- value}: }{
#'     Setter for a SimpleList or list (coerced to SimpleList) of \code{igraph}
#'     objects representing rows and columns, respectively.}
#'   \item{\code{rowGraph(x, i)} and \code{colGraph(x, i)}: }{
#'     Getter for an \code{igraph} object containing graph `i` from the list
#'     stored in \code{rowGraphs} and \code{colGraphs}, respectively.}
#'   \item{\code{rowGraph(x, i) <- value} and \code{colGraph(x, i) <- value}: }{
#'     Setter for an \code{igraph} object to be stored in element `i` of 
#'     \code{rowGraphs} and \code{colGraphs}.}
#' }
#' 
#' @section rowGraphNames and colGraphNames methods:
#' \describe{
#'   \item{\code{rowGraphNames(x)} and \code{colGraphNames(x)}: }{
#'     Getter to extract names of graphs in \code{rowGraphs} 
#'     and \code{colGraphs}.}
#'   \item{\code{rowGraphNames(x) <- value} and \code{colGraphNames(x) <- value}: }{
#'     Setter to assign new names to the graphs stored in \code{rowGraphs}
#'     and \code{colGraphs}.}
#' }
#' 
#' @section rowData method:
#' \describe{
#'   \item{\code{rowData(x)}: }{
#'     Getter to extract rowData (as in \code{SingleCellExperiment} objects),
#'     but with node attributes of graphs included.}
#' }
#' 
#' @section colData method:
#' \describe{
#'   \item{\code{colData(x)}: }{
#'     Getter to extract colData (as in \code{SingleCellExperiment} objects),
#'     but with node attributes of graphs included.}
#' }
#' 
#' @name GraphExperiment-methods
#' @aliases 
#' rowGraphs rowGraphs<- colGraphs colGraphs<-
#' rowGraph rowGraph<- colGraph colGraph<-
#' rowGraphNames rowGraphNames<- colGraphNames colGraphNames<-
#' rowData colData
#' 
#' @examples 
#' # Simulate elements of a GraphExperiment object
#' ## Assays
#' gene_ids <- paste0("gene", seq_len(200))
#' cell_ids <- paste0("cell", seq_len(100))
#' mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))
#' 
#' ## rowGraph (with node attributes)
#' g <- graph_from_adjacency_matrix(cor(t(mat)), weighted = TRUE)
#' V(g)$degree <- igraph::strength(g)
#' 
#' ## colGraph
#' g2 <- graph_from_adjacency_matrix(cor(mat), weighted = TRUE)
#' 
#' ## rowData
#' rdata <- data.frame(
#'     row.names = gene_ids, 
#'     pathway = sample(c("P1", "P2"), size = length(gene_ids), replace = TRUE),
#'     coding = sample(c(TRUE, FALSE), size = length(gene_ids), replace = TRUE)
#' )
#' 
#' ## colData
#' cdata <- data.frame(
#'     row.names = cell_ids, 
#'     celltype = sample(c("ct1", "ct2"), size = length(cell_ids), replace = TRUE)
#' )
#' 
#' 
#' # Create a GraphExperiment object
#' ge <- GraphExperiment(
#'     assays = list(counts = mat), 
#'     rowData = rdata,
#'     colData = cdata,
#'     rowGraphs = list(cor = g),
#'     colGraphs = list(cellcor = g2)
#' )
#' ge
#' 
#' # Extract graph names
#' rowGraphNames(ge)
#' colGraphNames(ge)
#' 
#' 
#' # Extract graphs
#' rowGraphs(ge)
#' rowGraph(ge, "cor")
#' 
#' colGraphs(ge)
#' colGraph(ge, "cellcor")
#' 
#' 
#' # Add a new graph
#' rowGraph(ge, "newcor") <- g
#' ge
#' 
#' # Add a list of graphs
#' colGraphs(ge) <- list(cellcor = g2, new_cellcor = g2)
#' ge
#' 
#' # Replace graph names
#' rowGraphNames(ge) <- c("network1", "network2")
#' ge
#' 
#' # Access rowData (note: rowData + node attributes combined)
#' rowData(ge)
#' 
#' # Access colData (note: colData + node attributes combined)
#' colData(ge)
#'
NULL

## Getters ---------------------------------------------------------------------


# rowData and colData ----------------------------------------------------------

#' @param use.names Passed to the \code{rowData} method of
#' \code{SingleCellExperiment}. Default: TRUE.
#' @rdname GraphExperiment-methods
#' @importFrom SummarizedExperiment rowData
#' @export
setMethod(
    "rowData", "GraphExperiment",
    function(x, use.names = TRUE, ...) {
        rdata <- callNextMethod()
        rdata <- .get_metadata(x@rowGraphs, rdata)
        
        return(rdata)
    }
)

#' @param use.names Passed to the \code{colData} method of
#' \code{SingleCellExperiment}. Default: TRUE.
#' @rdname GraphExperiment-methods
#' @importFrom SummarizedExperiment colData
#' @export
setMethod(
    "colData", "GraphExperiment",
    function(x, use.names = TRUE, ...) {
        cdata <- callNextMethod()
        cdata <- .get_metadata(x@colGraphs, cdata)
        
        return(cdata)
    }
)



# rowGraphs and colGraphs ------------------------------------------------------

#' @rdname GraphExperiment-methods
#' @export
setMethod(
    "rowGraphs", "GraphExperiment", 
    function(x) {
        glist <- x@rowGraphs
        if(length(glist) >0) {
            rdata <- rowData(x)
            glist <- SimpleList(lapply(glist, function(x) {
                .metadata2nat(rdata, x)
            }))
        }
        return(glist)
    }
)

#' @rdname GraphExperiment-methods
#' @export
setMethod(
    "colGraphs", "GraphExperiment", 
    function(x) {
        glist <- x@colGraphs
        if(length(glist) >0) {
            cdata <- colData(x)
            glist <- SimpleList(lapply(glist, function(x) {
                .metadata2nat(cdata, x)
            }))
        }
        return(glist)
    }
)


# rowGraph and colGraph --------------------------------------------------------

#' @rdname GraphExperiment-methods
#' @export
setMethod(
    "rowGraph", c("GraphExperiment", "missing"),
    function(x, i) {
        
        glist <- x@rowGraphs
        if(length(glist) == 0) {
            stop("The 'rowGraphs' slot is empty.")
        }
        .metadata2nat(rowData(x), glist[[1]])
    }
)

#' @rdname GraphExperiment-methods
#' @export
setMethod(
    "rowGraph", "GraphExperiment", 
    function(x, i) {
        
        tryCatch({
            .metadata2nat(rowData(x), x@rowGraphs[[i]])
        }, error = function(e) {
            stop("Invalid index or name. Could not find element ", i, " in 'rowGraphs'.")
        })
    } 
)

#' @rdname GraphExperiment-methods
#' @export
setMethod(
    "colGraph", c("GraphExperiment", "missing"),
    function(x, i) {
        
        glist <- x@colGraphs
        if(length(glist) == 0) {
            stop("The 'colGraphs' slot is empty.")
        }
        .metadata2nat(colData(x), glist[[1]])
    }
)

#' @rdname GraphExperiment-methods
#' @export
setMethod(
    "colGraph", "GraphExperiment", 
    function(x, i) {
        
        tryCatch({
            .metadata2nat(colData(x), x@colGraphs[[i]])
        }, error = function(e) {
            stop("Invalid index or name. Could not find element ", i, " in 'colGraphs'.")
        })
    } 
)

# rowGraphNames and colGraphNames ----------------------------------------------

#' @rdname GraphExperiment-methods
#' @export
setMethod(
    "rowGraphNames", "GraphExperiment",
    function(x) {
        names(rowGraphs(x))
    }
)

#' @rdname GraphExperiment-methods
#' @export
setMethod(
    "colGraphNames", "GraphExperiment",
    function(x) {
        names(colGraphs(x))
    }
)


## Setters ----

#' @rdname GraphExperiment-methods
#' @export
#' @importFrom BiocBaseUtils setSlots
setReplaceMethod(
    "rowGraphs", "GraphExperiment",
    function(x, value) {
        
        if(is(value, "list")) { value <- SimpleList(value) }
        setSlots(x, rowGraphs = value)
    }
)

#' @rdname GraphExperiment-methods
#' @export
#' @importFrom BiocBaseUtils setSlots
setReplaceMethod(
    "colGraphs", "GraphExperiment",
    function(x, value) {
        
        if(is(value, "list")) { value <- SimpleList(value) }
        setSlots(x, colGraphs = value)
    }
)




#' @rdname GraphExperiment-methods
#' @export
setReplaceMethod(
    "rowGraph", "GraphExperiment",
    function(x, i, value) {
        rowGraphs(x)[[i]] <- value
        x
    }
)

#' @rdname GraphExperiment-methods
#' @export
setReplaceMethod(
    "colGraph", "GraphExperiment",
    function(x, i, value) {
        colGraphs(x)[[i]] <- value
        x
    }
)




#' @rdname GraphExperiment-methods
#' @export
setReplaceMethod(
    "rowGraphNames", c("GraphExperiment", "character"),
    function(x, value) {
        names(rowGraphs(x)) <- value
        x
    }
)

#' @rdname GraphExperiment-methods
#' @export
setReplaceMethod(
    "colGraphNames", c("GraphExperiment", "character"),
    function(x, value) {
        names(colGraphs(x)) <- value
        x
    }
)

#' The `GraphExperiment` S4 class
#' 
#' The `GraphExperiment` class was designed to represent rectangular, 
#' quantitative data (e.g., from transcriptomics, proteomics, metabolomics) 
#' along with graphs showing how features (e.g., genes, proteins, compounds)
#' and observations (e.g., samples, cells, species, spots) interact with each 
#' other. It extends \code{SingleCellExperiment} by providing users with 
#' additional slots where row/column graphs can be stored.
#'
#' @param ... Arguments passed to the \code{SingleCellExperiment} constructor
#' function.
#' @param rowGraphs A list of `igraph` objects with one or multiple graphs
#' representing how features relate to each other. Node names (i.e., 
#' \code{V(graph)$name}) must match rownames of assays.
#' @param colGraphs A list of `igraph` objects with one or multiple graphs
#' representing how observations relate to each other. Node names (i.e., 
#' \code{V(graph)$name}) must match colnames of assays.
#' 
#' @return A \code{GraphExperiment} object.
#'
#' @details
#' Like \code{SingleCellExperiment}, the \code{GraphExperiment} S4 
#' class stores quantitative data with associated metadata (i.e., 
#' \code{rowData} and \code{colData}) along with embeddings from dimensionality 
#' reduction techniques. However, it provides users with additional 
#' containers for \code{igraph} objects containing graphs describing how 
#' features and/or observations interact with each other. Graphs for features 
#' are stored in a \code{rowGraphs} slot, and graphs for observations are
#' stored in a \code{colGraphs} slot. Both slots can hold one or 
#' multiple \code{igraph} objects with some sort of network representation of 
#' the features in \code{rownames} or observations in \code{colnames}. Example
#' graphs for features can be coexpression networks, regulatory networks, 
#' or co-abundance networks. Example graphs for observations can be 
#' cell-cell distances, sample-sample distances, or species networks 
#' representing genealogies (as an alternative to phylogenies).
#'
#' Importantly, node names in each row graph must match \code{rownames} of the
#' assays, and node names in each column graph must match \code{colnames} of
#' the assays. Besides, subsetting methods simultaneously subset \code{assays}, 
#' \code{rowData}, \code{rowGraphs}, \code{colData}, and \code{colGraphs}.
#' 
#' Besides the constructor function (\code{GraphExperiment()}), a 
#' \code{GraphExperiment} object can also be created by coercing from a
#' \code{SummarizedExperiment} or 
#' \code{SingleCellExperiment} object.
#' 
#' @rdname GraphExperiment
#' @importFrom SingleCellExperiment SingleCellExperiment
#' @importFrom S4Vectors SimpleList
#' @importFrom methods new as
#' @export
#' @examples
#' # Example 1: from constructor function ----
#' ## Simulate a matrix with 200 genes and 100 cells
#' gene_ids <- paste0("gene", seq_len(200))
#' cell_ids <- paste0("cell", seq_len(100))
#' mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))
#'
#' ## Create a rowGraph from correlations (`igraph` object)
#' g <- graph_from_adjacency_matrix(cor(t(mat)), weighted = TRUE)
#' 
#' ## Create a colGraph, also from correlations (but see scran::buildSNNGraph)
#' g2 <- graph_from_adjacency_matrix(cor(mat), weighted = TRUE)
#'
#' ## Construct `GraphExperiment` object
#' ge <- GraphExperiment(
#'     assays = list(counts = mat),
#'     rowGraphs = list(cor = g),
#'     colGraphs = list(cellcor = g2)
#' )
#' ge
#' 
#' # Example 2: From `SingleCellExperiment` object ----
#' sce <- SingleCellExperiment(assays = list(counts = mat))
#' ge <- as(sce, "GraphExperiment")
#' ge
#' 
GraphExperiment <- function(..., rowGraphs = list(), colGraphs = list()) {
    
    sce <- SingleCellExperiment(...)
    
    # rowGraphs
    if(is(rowGraphs, "list")) { rowGraphs <- SimpleList(rowGraphs) }
    if(is.null(names(rowGraphs)) & length(rowGraphs) >0) {
        names(rowGraphs) <- paste0("graph", seq_along(rowGraphs))
    }
    
    # colGraphs
    if(is(colGraphs, "list")) { colGraphs <- SimpleList(colGraphs) }
    if(is.null(names(colGraphs)) & length(colGraphs) >0) {
        names(colGraphs) <- paste0("graph", seq_along(colGraphs))
    }
    
    ge <- new(
        "GraphExperiment", sce, rowGraphs = rowGraphs, colGraphs = colGraphs
    )
    
    return(ge)
}

# Create example data ----
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))
rg <- graph_from_adjacency_matrix(cor(t(mat)), weighted = TRUE)
cg <- graph_from_adjacency_matrix(cor(mat), weighted = TRUE)

# Start tests ----
test_that(".node_validity works", {
    
    ## Nodes in graph but not in rownames
    expect_error(
        GraphExperiment(assays = list(counts = mat[1:90, ]), rowGraphs = list(cor = rg))
    )
    
    ## Nodes in graph but not in colnames
    expect_error(
        GraphExperiment(assays = list(counts = mat[, 1:90]), colGraphs = list(cor = cg))
    )
    
    ## Nodes in rownames but not in graph
    mat3 <- mat[1:10, ]
    rownames(mat3) <- paste0("gene", LETTERS[1:10])
    mat3 <- rbind(mat, mat3)
    expect_error(
        GraphExperiment(assays = list(counts = mat3), rowGraphs = list(cor = rg))
    )
    
    ## Nodes in colnames but not in graph
    mat4 <- mat[, 1:10]
    colnames(mat4) <- paste0("cell", LETTERS[1:10])
    mat4 <- cbind(mat, mat4)
    expect_error(
        GraphExperiment(assays = list(counts = mat4), colGraphs = list(cor = cg))
    )
    
})

test_that(".graphs_validity works", {
    
    ge <- GraphExperiment(assays = list(counts = mat), rowGraphs = list(cor = rg))
    
    ## graphs slot is not list, SimpleList, or NULL
    expect_error(rowGraphs(ge) <- NA)
    expect_error(colGraphs(ge) <- NA)
    
    expect_error(
        GraphExperiment(assays = list(counts = mat), rowGraphs = list(cor = "graph"))
    )
    
})

# Construct `GraphExperiment` object ----
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))

g <- graph_from_adjacency_matrix(cor(t(mat)), weighted = TRUE)
V(g)$degree <- igraph::strength(g)

g2 <- graph_from_adjacency_matrix(cor(mat), weighted = TRUE)

rdata <- data.frame(
    row.names = gene_ids,
    pathway = sample(c("P1", "P2"), size = length(gene_ids), replace = TRUE),
    coding = sample(c(TRUE, FALSE), size = length(gene_ids), replace = TRUE)
)

cdata <- data.frame(
    row.names = cell_ids,
    celltype = sample(c("ct1", "ct2"), size = length(cell_ids), replace = TRUE)
)

ge <- GraphExperiment(
    assays = list(counts = mat),
    rowData = rdata,
    colData = cdata,
    rowGraphs = list(cor = g),
    colGraphs = list(cellcor = g2)
)
ge


# Start tests ----
test_that("Constructor function works", {
    ge1 <- GraphExperiment(
        assays = list(counts = mat), 
        rowGraphs = list(cor = g), colGraphs = list(cellcor = g2)
    )
    
    rg2 <- igraph::delete_vertices(g, paste0("gene", 1:10))
    cg2 <- igraph::delete_vertices(g2, paste0("cell", 1:10))
    
    expect_s4_class(ge1, "GraphExperiment")
    expect_error(
        GraphExperiment(assays = list(counts = mat), rowGraphs = "graph")
    )
    expect_error(
        GraphExperiment(assays = list(counts = mat), colGraphs = "graph")
    )
    
    expect_error(
        GraphExperiment(assays = list(counts = mat), rowGraphs = list("graph"))
    )
    expect_error(
        GraphExperiment(assays = list(counts = mat), colGraphs = list("graph"))
    )
    
    expect_error(
        GraphExperiment(assays = list(counts = mat), rowGraphs = rg2)
    )
    expect_error(
        GraphExperiment(assays = list(counts = mat), colGraphs = cg2)
    )
    
})

test_that("Getters work", {
    
    ## Basic GE object
    expect_true(is(rowGraphs(ge), "SimpleList"))
    expect_true(is(rowGraph(ge, 1), "igraph"))
    expect_true(is(rowGraph(ge), "igraph"))
    expect_equal(rowGraphNames(ge), "cor")
    
    expect_true(is(colGraphs(ge), "SimpleList"))
    expect_true(is(colGraph(ge, 1), "igraph"))
    expect_true(is(colGraph(ge), "igraph"))
    expect_equal(colGraphNames(ge), "cellcor")
    
    ## More complex GE objects
    ge2 <- ge
    V(rowGraph(ge2, 1))$rnum <- rnorm(vcount(rowGraph(ge2)))
    V(colGraph(ge2, 1))$cnum <- rnorm(vcount(colGraph(ge2)))
    
    expect_equal(length(rowData(ge)), 3)
    expect_true(length(rowData(ge2)) >3)
    
    at_names <- igraph::vertex_attr_names(rowGraph(ge))
    expect_true(all(gsub(".*__", "", colnames(rowData(ge))) %in% at_names))
    
    at_names2 <- igraph::vertex_attr_names(colGraph(ge))
    expect_true(all(gsub(".*__", "", colnames(colData(ge))) %in% at_names2))
    
    ## Empty graph
    ge_empty <- ge
    rowGraphs(ge_empty) <- NULL
    colGraphs(ge_empty) <- NULL
    
    expect_error(rowGraph(ge_empty))
    expect_error(colGraph(ge, 10))
})

test_that("Setters work", {
    
    nge <- ge
    rowGraphs(nge) <- list(g1 = g, g2 = g)
    rowGraphNames(nge) <- c("graph1", "graph2")
    rowGraph(nge, 1) <- g
    
    colGraphs(nge) <- list(g1 = g2, g2 = g2)
    colGraphNames(nge) <- c("cgraph1", "cgraph2")
    colGraph(nge, 1) <- g2
    
    expect_true(is(rowGraph(nge, 1), "igraph"))
    expect_true(is(rowGraphs(nge)[[1]], "igraph"))
    expect_equal(rowGraphNames(nge), c("graph1", "graph2"))
    expect_error(rowGraphs(nge) <- "graphs")
    expect_error(rowGraph(nge) <- "graph")
    expect_error(rowGraphNames(nge) <- c(1, 2))
    
    expect_true(is(colGraph(nge, 1), "igraph"))
    expect_true(is(colGraphs(nge)[[1]], "igraph"))
    expect_equal(colGraphNames(nge), c("cgraph1", "cgraph2"))
    expect_error(colGraphs(nge) <- "graphs")
    expect_error(colGraph(nge) <- "graph")
    expect_error(colGraphNames(nge) <- c(1, 2))
})

test_that("show method works", {

    expect_null(show(ge))
})

# Create example `GraphExperiment` object
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))

rg <- graph_from_adjacency_matrix(cor(t(mat)), weighted = TRUE)
V(rg)$degree <- igraph::strength(rg)

cg <- graph_from_adjacency_matrix(cor(mat), weighted = TRUE)

rdata <- data.frame(
    row.names = gene_ids,
    pathway = sample(c("P1", "P2"), size = length(gene_ids), replace = TRUE),
    coding = sample(c(TRUE, FALSE), size = length(gene_ids), replace = TRUE)
)

cdata <- data.frame(
    row.names = cell_ids,
    celltype = sample(c("ct1", "ct2"), size = length(cell_ids), replace = TRUE)
)

ge <- GraphExperiment(
    assays = list(counts = mat),
    rowData = rdata,
    colData = cdata,
    rowGraphs = list(cor = rg),
    colGraphs = list(cellcor = cg)
)
ge

# Start tests ----
test_that("Subsetting rows also subsets nodes", {
    
    fge <- ge[1:5, 1:5]
    
    expect_equal(nrow(fge), 5)
    expect_equal(vcount(rowGraph(fge, 1)), 5)
    
    expect_equal(ncol(fge), 5)
    expect_equal(vcount(colGraph(fge, 1)), 5)
    
    expect_equal(dim(ge[, ]), dim(ge))
})

#' @importFrom methods callNextMethod
#' @importFrom S4Vectors coolcat
setMethod(
    "show", "GraphExperiment",
    function(object) {
        callNextMethod()
        coolcat("rowGraphs(%d): %s\n", rowGraphNames(object))
        coolcat("colGraphs(%d): %s\n", colGraphNames(object))
    }
)

#' Add rowData or colData variables to node attributes of `igraph` objects
#' 
#' @importFrom igraph set_vertex_attr vertex_attr_names
#' @noRd
.metadata2nat <- function(metadata, graph) {
    
    # Remove rowData vars extracted from graph node attributes
    idx_remove <- grepl("__", names(metadata))
    if(sum(idx_remove) >0) { metadata <- metadata[, !idx_remove, drop = FALSE] }
    
    # Add missing row/coldata vars to node attributes
    fgraph <- graph
    if(length(metadata) >0) {
        nat_list <- as.list(metadata)
        
        if(length(nat_list) >0) {
            idx <- match(rownames(metadata), V(graph)$name)
            for(rvar in names(nat_list)) {
                fgraph <- set_vertex_attr(
                    fgraph, name = rvar, index = idx, value = nat_list[[rvar]]
                )
            }
        }
    }
    
    return(fgraph)
}


#' Retrieve rowData/colData that combines node attributes of `igraph` object
#' 
#' @importFrom igraph as_data_frame
#' @noRd
.get_metadata <- function(graph_list, metadata) {
    
    glist <- graph_list
    gnames <- names(glist)
    
    # Get a data frame of node attributes for all graphs (if any)
    nodeat_df <- NULL
    if(length(glist) > 0) {
        nodeat_df <- Reduce(cbind, lapply(seq_along(glist), function(n) {
            df <- igraph::as_data_frame(glist[[n]], what = "vertices")

            remove_idx <- which(names(df) %in% colnames(metadata)) 
            
            names(df) <- paste0(gnames[n], "__", names(df))
            df <- df[, -c(1, remove_idx), drop = FALSE]
            return(df)
        }))
    }
    
    # Extend row/colData to include node attributes
    if(length(nodeat_df) > 0) {
        idx_cbind <- match(rownames(metadata), rownames(nodeat_df))
        metadata <- cbind(metadata, nodeat_df[idx_cbind, , drop = FALSE])
    }
    
    return(metadata)
}

setClassUnion("list_or_SimpleList", c("list", "SimpleList", "NULL"))

#' `GraphExperiment` S4 class
#' 
#' @export
#' @rdname GraphExperiment
#' @importClassesFrom SingleCellExperiment SingleCellExperiment
#' @importClassesFrom S4Vectors SimpleList
setClass(
    "GraphExperiment",
    contains = "SingleCellExperiment",
    slots = c(
        rowGraphs = "list_or_SimpleList",
        colGraphs = "list_or_SimpleList"
    ),
    prototype = prototype(rowGraphs = list(), colGraphs = list())
)

#' Coercion methods for `GraphExperiment` objects
#' 
#' The \code{GraphExperiment} class inherits from \code{SingleCellExperiment},
#' which in turn inherits from \code{(Ranged)SummarizedExperiment}. To ensure
#' \code{GraphExperiment} easily interoperates with these classes, we provide
#' users with traditional \code{as()} coercion methods.
#'
#' @param from An object of class \code{SingleCellExperiment}, 
#' \code{SummarizedExperiment}, or \code{RangedSummarizedExperiment} to be 
#' coerced to \code{GraphExperiment}.
#' 
#' @return A \code{GraphExperiment} object.
#' 
#' @name GraphExperiment-coerce
#' @aliases 
#' coerce,SingleCellExperiment,GraphExperiment-method
#' coerce,SummarizedExperiment,GraphExperiment-method
#' coerce,RangedSummarizedExperiment,GraphExperiment-method
#' 
#' @examples 
#' # Simulate a count matrix
#' gene_ids <- paste0("gene", seq_len(200))
#' cell_ids <- paste0("cell", seq_len(100))
#' mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))
#' 
#' # Coerce from `SummarizedExperiment`
#' se <- SummarizedExperiment(assays = list(mat))
#' as(se, "GraphExperiment")
#' 
#' # Coerce from `RangedSummarizedExperiment`
#' rse <- as(se, "RangedSummarizedExperiment")
#' as(rse, "GraphExperiment")
#' 
#' # Coerce from `SingleCellExperiment`
#' sce <- as(se, "SingleCellExperiment")
#' as(sce, "GraphExperiment")
NULL


#' @export
#' @importClassesFrom SingleCellExperiment SingleCellExperiment
setAs(
    "SingleCellExperiment", "GraphExperiment", 
    function(from) {
        new("GraphExperiment", from, rowGraphs = SimpleList(), colGraphs = SimpleList())
    }
)

#' @export
#' @importClassesFrom SummarizedExperiment SummarizedExperiment 
setAs(
    "SummarizedExperiment", "GraphExperiment", 
    function(from) {
        new("GraphExperiment", as(from, "SingleCellExperiment"), rowGraphs = SimpleList(), colGraphs = SimpleList())
    }
)

#' @export
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment 
setAs(
    "RangedSummarizedExperiment", "GraphExperiment", 
    function(from) {
        new("GraphExperiment", as(from, "SingleCellExperiment"), rowGraphs = SimpleList(), colGraphs = SimpleList())
    }
)

#' @importFrom igraph V
.nodes_validity_rowgraphs <- function(object) {
    
    graph_list <- object@rowGraphs
    if(length(graph_list) == 0) return(NULL)
    rn <- rownames(object)
    
    msg <- NULL
    msgs <- unlist(lapply(seq_along(graph_list), function(i) {
        g <- graph_list[[i]]
        graph_name <- names(graph_list)[i]
        
        node_names <- V(g)$name
        
        # Check for features in rownames but not in graph
        missing_from_graph <- setdiff(rn, node_names)
        if(length(missing_from_graph) > 0) {
            msg <- c(msg, sprintf(
                "%d feature(s) in 'rownames' are missing from graph '%s'.",
                length(missing_from_graph), graph_name
            ))
        }
        
        # Check for nodes in graph but not in rownames
        missing_from_rownames <- setdiff(node_names, rn)
        if(length(missing_from_rownames) > 0) {
            msg <- c(msg, sprintf(
                "%d node(s) in graph '%s' are missing from 'rownames'.",
                length(missing_from_rownames), graph_name
            ))
        }
        
        return(msg)
    }))
    
    return(msgs)
}

.nodes_validity_colgraphs <- function(object) {
    
    graph_list <- object@colGraphs
    if(length(graph_list) == 0) return(NULL)
    cn <- colnames(object)
    
    msg <- NULL
    msgs <- unlist(lapply(seq_along(graph_list), function(i) {
        g <- graph_list[[i]]
        graph_name <- names(graph_list)[i]
        
        node_names <- V(g)$name
        
        # Check for observations in colnames but not in graph
        missing_from_graph <- setdiff(cn, node_names)
        if(length(missing_from_graph) > 0) {
            msg <- c(msg, sprintf(
                "%d observations(s) in 'colnames' are missing from graph '%s'.",
                length(missing_from_graph), graph_name
            ))
        }
        
        # Check for observations in graph but not in colnames
        missing_from_rownames <- setdiff(node_names, cn)
        if(length(missing_from_rownames) > 0) {
            msg <- c(msg, sprintf(
                "%d node(s) in graph '%s' are missing from 'colnames'.",
                length(missing_from_rownames), graph_name
            ))
        }
        
        return(msg)
    }))
    
    return(msgs)
}


#' @importFrom methods is
.graphs_validity <- function(object) {
    
    rg <- object@rowGraphs
    cg <- object@colGraphs
    
    # Check that each element is an igraph object
    if(length(rg) > 0) {
        msgs <- unlist(lapply(seq_along(rg), function(i) {
            graph_name <- names(rg)[i]
            if(!is(rg[[i]], "igraph")) {
                return(sprintf("Graph '%s' in rowGraphs is not an igraph object", graph_name))
            }
        }))
    }
    
    if(length(cg) > 0) {
        msgs <- unlist(lapply(seq_along(cg), function(i) {
            graph_name <- names(cg)[i]
            if(!is(cg[[i]], "igraph")) {
                return(sprintf("Graph '%s' in colGraphs is not an igraph object", graph_name))
            }
        }))
    }
    
    return(NULL)
}


.ge_validity <- function(object) {
    
    msg <- .graphs_validity(object)
    if(!is.null(msg)) return(msg)
    
    msg <- .nodes_validity_rowgraphs(object)
    if(!is.null(msg)) return(msg)
    
    msg <- .nodes_validity_colgraphs(object)
    if(!is.null(msg)) return(msg)
    
    return(TRUE)
}


#' @importFrom S4Vectors setValidity2
setValidity2("GraphExperiment", .ge_validity)

## Getters ---------------------------------------------------------------------

#' @export
setGeneric("rowGraphs", function(x, ...) standardGeneric("rowGraphs"))

#' @export
setGeneric("colGraphs", function(x, ...) standardGeneric("colGraphs"))




#' @export
setGeneric(
    "rowGraph", signature = c("x", "i"),
    function(x, i, ...) standardGeneric("rowGraph")
)

#' @export
setGeneric(
    "colGraph", signature = c("x", "i"),
    function(x, i, ...) standardGeneric("colGraph")
)




#' @export
setGeneric("rowGraphNames", function(x, ...) standardGeneric("rowGraphNames"))

#' @export
setGeneric("colGraphNames", function(x, ...) standardGeneric("colGraphNames"))


## Setters ---------------------------------------------------------------------

#' @export
setGeneric("rowGraphs<-", function(x, ..., value) standardGeneric("rowGraphs<-"))

#' @export
setGeneric("colGraphs<-", function(x, ..., value) standardGeneric("colGraphs<-"))




#' @export
setGeneric(
    "rowGraph<-", signature = c("x", "i"),
    function(x, i, ..., value) standardGeneric("rowGraph<-")
)

#' @export
setGeneric(
    "colGraph<-", signature = c("x", "i"),
    function(x, i, ..., value) standardGeneric("colGraph<-")
)




#' @export
setGeneric("rowGraphNames<-", function(x, ..., value) standardGeneric("rowGraphNames<-"))

#' @export
setGeneric("colGraphNames<-", function(x, ..., value) standardGeneric("colGraphNames<-"))

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    crop = NULL
)

## ----installation, eval=FALSE-------------------------------------------------
# if(!requireNamespace('BiocManager', quietly = TRUE))
#   install.packages('BiocManager')
# 
# BiocManager::install("GraphExperiment")

## ----load_package, message=FALSE----------------------------------------------
# Load package after installation
library(GraphExperiment)

set.seed(777) # for reproducibility

## ----fig, echo=FALSE, out.width = "100%", fig.cap="The GraphExperiment class."----
knitr::include_graphics("GraphExperiment.png")

## ----simulate_slots, message=FALSE--------------------------------------------
# Simulate parts of a `GraphExperiment` object
## Assays
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))
mat[1:5, 1:5]

## rowData
rdata <- data.frame(
    row.names = gene_ids,
    pathway = sample(c("P1", "P2"), size = length(gene_ids), replace = TRUE),
    coding = sample(c(TRUE, FALSE), size = length(gene_ids), replace = TRUE)
)
head(rdata)

## colData
cdata <- data.frame(
    row.names = cell_ids, 
    cell_type = sample(c("ct1", "ct2"), size = length(cell_ids), replace = TRUE)
)
head(cdata)

## rowGraph (with node attribute `degree`)
rg <- graph_from_adjacency_matrix(
    cor(t(mat)), mode = "undirected", weighted = TRUE
)
rg <- set_vertex_attr(rg, "degree", value = strength(rg))
rg

## colGraph
cg <- graph_from_adjacency_matrix(
    cor(mat), mode = "undirected", weighted = TRUE
)

## ----create_ge----------------------------------------------------------------
# Create a `GraphExperiment` object
ge <- GraphExperiment(
    assays = list(counts = mat),
    rowData = rdata,
    colData = cdata,
    rowGraphs = list(gene_cor = rg),
    colGraphs = list(cell_cor = cg)
)
ge

## ----error_missing_from_graph, error = TRUE-----------------------------------
try({
# Remove 'gene1' to 'gene10' from the rowGraph and try to recreate object
rg2 <- delete_vertices(rg, paste0("gene", 1:10))
GraphExperiment(
    assays = list(counts = mat),
    rowData = rdata,
    colData = cdata,
    rowGraphs = list(gene_cor = rg2)
)
})

## ----coerce_se----------------------------------------------------------------
# Coercing from `SummarizedExperiment`
se <- SummarizedExperiment(list(counts = mat))
ge1 <- as(se, "GraphExperiment")
ge1

## ----graphNames---------------------------------------------------------------
# Get rowGraph names
rowGraphNames(ge)      # 'gene_cor'
rowGraphNames(ge1)     # empty (NULL)

# Get colGraph names
colGraphNames(ge)      # 'cell_cor'
colGraphNames(ge1)     # empty (NULL)

## ----getters------------------------------------------------------------------
# Get rowGraphs
rowGraphs(ge)

# Get colGraphs
colGraphs(ge)

# Get first rowGraph by index
rowGraph(ge, 1)

# Get first rowGraph by index (alternative)
rowGraphs(ge)[[1]]

# Get graph by name
rowGraph(ge, "gene_cor")

## ----rowdata_getter-----------------------------------------------------------
# `rowGraphs` and `rowData` are always in sync!
rowData(ge)

# `colGraphs` and `colData` too - yay!
colGraph(ge, 1) # note the `cell_type` attribute extracted from `colData`

## ----graph_setter-------------------------------------------------------------
# Create a new rowGraph without correlations between -0.4 and 0.4
rg_filt <- rowGraph(ge, "gene_cor") |> 
    delete_vertex_attr("pathway") |>
    delete_vertex_attr("degree") |>
    delete_vertex_attr("coding")

todelete <- abs(E(rg_filt)$weight) <0.4
rg_filt <- delete_edges(rg_filt, which(todelete))
rg_filt

# Add filtered graph a new graph named `fcor`
rowGraph(ge, "filt_genecor") <- rg_filt
ge

## ----graphs_setter------------------------------------------------------------
# Taking a quick look (note: nothing in `rowGraphs`/`colGraphs`)
ge1

# Adding graphs from `ge`
rowGraphs(ge1) <- rowGraphs(ge)
colGraphs(ge1) <- colGraphs(ge)
ge1

## ----graphNames_setter--------------------------------------------------------
# Rename graphs
rowGraphNames(ge1) <- c("correlations", "correlations_filtered_0.4")
colGraphNames(ge1) <- c("cell_correlations")
ge1

## ----subset-------------------------------------------------------------------
# Subsetting `GraphExperiment` object
ge_subset <- ge[1:10, 1:10]

ge_subset
rowGraph(ge_subset, "gene_cor")

## ----session_info-------------------------------------------------------------
sessioninfo::session_info()

# Create example objects for each `from` class ----
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))

se <- SummarizedExperiment(assays = list(mat))
rse <- as(se, "RangedSummarizedExperiment")
sce <- as(se, "SingleCellExperiment")

# Start tests ----
test_that("coercion methods work", {
    
    ex1 <- as(se, "GraphExperiment")
    ex2 <- as(rse, "GraphExperiment")
    ex3 <- as(sce, "GraphExperiment")
    
    expect_s4_class(ex1, "GraphExperiment")
    expect_s4_class(ex2, "GraphExperiment")
    expect_s4_class(ex3, "GraphExperiment")
})

---
title: "Introduction to the GraphExperiment class"
author: 
  - name: Fabricio Almeida-Silva
    affiliation: |
      VIB-UGent Center for Plant Systems Biology, Ghent University, 
      Ghent, Belgium
  - name: Yves Van de Peer
    affiliation: |
      VIB-UGent Center for Plant Systems Biology, Ghent University, 
      Ghent, Belgium
output: 
  BiocStyle::html_document:
    toc: true
    number_sections: yes
bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{Introduction to the GraphExperiment class}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    crop = NULL
)
```

# Introduction

Networks (or graphs) have become widely used data representations in biology, 
as they can efficiently encode node-node interactions and neighborhoods.
In high-throughput, quantitative omics data (e.g., transcriptomics, proteomics,
metabolomics, epigenomics, etc), widely used feature-level 
network representations include
gene coexpression, protein-protein interaction, gene regulatory, and 
co-abundance networks, and cell-cell communication,
sample-sample similarity, and species-species networks at the observation 
level. While data structures to store quantitative data and
associated metadata exist (e.g., `SummarizedExperiment`, `SingleCellExperiment`,
`SpatialExperiment`, etc), support for networks describing how features
(i.e., assay rows) and/or observations (i.e., assay columns) relate
to each other is currently missing. `GraphExperiment` is an S4 class that 
extends `SingleCellExperiment` [@sce] to include additional containers 
for networks associated with assay features (`rowGraphs`) and
assay observations (`colGraphs`).

Of note, trees are an alternative way of representing how assay 
features/observations are related to each other. Users interested in tree
representations of assays rows/columns can use 
the `r BiocStyle::Biocpkg("TreeSummarizedExperiment")` package. 
Trees are essentially *a kind of graph* (i.e., all trees are graphs,
but not all graphs are trees). Here, we chose to use a more
general graph representation (namely `igraph` objects) to provide users and 
developers with more flexibility.

# Installation

`GraphExperiment` can be installed from Bioconductor with the following code:

```{r installation, eval=FALSE}
if(!requireNamespace('BiocManager', quietly = TRUE))
  install.packages('BiocManager')

BiocManager::install("GraphExperiment")
```

```{r load_package, message=FALSE}
# Load package after installation
library(GraphExperiment)

set.seed(777) # for reproducibility
```

# Anatomy of a `GraphExperiment` object

Since the `GraphExperiment` class extends the `SingleCellExperiment` class,
all `SingleCellExperiment` slots are present in `GraphExperiment`, including:

- `assays`: list of matrices with primary (e.g., counts) and transformed (e.g.,
log-normalized counts, TPM, etc) data, with features in rows and observations
in columns.
- `colData`: a data frame with column (observation) metadata, such
as cell type, sample ID, condition, batch ID, genotype, etc.
- `rowData`: a data frame with row (feature) metadata, such as gene ID,
genomic coordinates, functional annotation, etc.
- `reducedDims`: list of data frames with reduced dimensions, such as PCA,
t-SNE, and UMAP embeddings.

Compared to `SingleCellExperiment` objects, `GraphExperiment` 
provides two additional containers: [^1]

- `rowGraphs`: list of `igraph` objects containing graphs representing
feature-feature relationships, including (but optional) node and 
edge attributes.
- `colGraphs`: list of `igraph` objects containing graphs representing
observation-observation relationships, including (but optional) node and 
edge attributes.

```{r fig, echo=FALSE, out.width = "100%", fig.cap="The GraphExperiment class."}
knitr::include_graphics("GraphExperiment.png")
```

[^1]: **Note on software design:** if you're familiar with 
`SingleCellExperiment` objects, you probably know that it offers 
`rowPairs`/`colPairs` slots to store pairwise relationships between rows and
columns of assays, respectively. 
In theory, some of the data stored in `rowGraphs`/`colGraphs` (of a 
`GraphExperiment` object) could be stored in `rowPairs`/`colPairs` (of a 
`SingleCellExperiment`). However, we chose to implement a dedicated slot with
`igraph` objects to guarantee (i) seamless interoperability with other
packages, given that `igraph` is the de facto standard class for graphs in R; 
and (ii) convenience in methods (e.g., subsetting, integration with 
`rowData`/`colData`, integration across multiple graphs, etc).


The `igraph` data class from the `r BiocStyle::CRANpkg("igraph")` package
is the standard data structure for graph representation in R. If you are
unfamiliar with `igraph` objects, you can learn more about it by reading 
the `r BiocStyle::CRANpkg("igraph")` vignettes.


# Building a `GraphExperiment` object

`GraphExperiment` objects can be created from scratch using the constructor
function `GraphExperiment()`. Below we will simulate a scRNA-seq count matrix 
with some gene (row) and cell (column) metadata, and create graphs based 
on gene-gene and cell-cell correlations [^2].

[^2]: **Tip:** in day-to-day single-cell RNA-seq analyses, researchers
typically infer cell-cell graphs based on shared nearest-neighbors (SNN), 
which are then used to find clusters that can be mapped to cell types. 
Readers interested in this sort of graph can have a look 
at the `buildSNNGraph()` function from the `r BiocStyle::Biocpkg("scran")` 
package.

```{r simulate_slots, message=FALSE}
# Simulate parts of a `GraphExperiment` object
## Assays
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))
mat[1:5, 1:5]

## rowData
rdata <- data.frame(
    row.names = gene_ids,
    pathway = sample(c("P1", "P2"), size = length(gene_ids), replace = TRUE),
    coding = sample(c(TRUE, FALSE), size = length(gene_ids), replace = TRUE)
)
head(rdata)

## colData
cdata <- data.frame(
    row.names = cell_ids, 
    cell_type = sample(c("ct1", "ct2"), size = length(cell_ids), replace = TRUE)
)
head(cdata)

## rowGraph (with node attribute `degree`)
rg <- graph_from_adjacency_matrix(
    cor(t(mat)), mode = "undirected", weighted = TRUE
)
rg <- set_vertex_attr(rg, "degree", value = strength(rg))
rg

## colGraph
cg <- graph_from_adjacency_matrix(
    cor(mat), mode = "undirected", weighted = TRUE
)
```

To create a `GraphExperiment` object from the constructor function, you would
run:

```{r create_ge}
# Create a `GraphExperiment` object
ge <- GraphExperiment(
    assays = list(counts = mat),
    rowData = rdata,
    colData = cdata,
    rowGraphs = list(gene_cor = rg),
    colGraphs = list(cell_cor = cg)
)
ge
```

If you're familiar with `SummarizedExperiment` and `SingleCellExperiment` 
objects, you will certainly recognize nearly everything you see in `ge`.
Compared to `SingleCellExperiment` objects, the only difference here is
in the last two rows, which indicate that this object contains a `rowGraph` 
named 'gene_cor' and a `colGraph` named 'cell_cor'.

Importantly, since nodes of `rowGraphs`/`colGraphs` are always in sync 
with `rownames`/`colnames`, 
**feature IDs in rownames and rowGraphs must be the same**, and
likewise for observation IDs in colnames and colGraphs.
For example, attempting to create a `GraphExperiment` object with some
features from `rownames` missing would lead to an error:

```{r error_missing_from_graph, error = TRUE}
# Remove 'gene1' to 'gene10' from the rowGraph and try to recreate object
rg2 <- delete_vertices(rg, paste0("gene", 1:10))
GraphExperiment(
    assays = list(counts = mat),
    rowData = rdata,
    colData = cdata,
    rowGraphs = list(gene_cor = rg2)
)
```

Alternatively, you can create a `GraphExperiment` object by coercing from
an existing `(Ranged)SummarizedExperiment` or `SingleCellExperiment` object.
For example:

```{r coerce_se}
# Coercing from `SummarizedExperiment`
se <- SummarizedExperiment(list(counts = mat))
ge1 <- as(se, "GraphExperiment")
ge1
```

Note that the `rowGraphs`/`colGraphs` containers are still there, but empty. 

To access the names of all graphs, you will use the `rowGraphNames()` and
`colGraphNames()` functions.

```{r graphNames}
# Get rowGraph names
rowGraphNames(ge)      # 'gene_cor'
rowGraphNames(ge1)     # empty (NULL)

# Get colGraph names
colGraphNames(ge)      # 'cell_cor'
colGraphNames(ge1)     # empty (NULL)
```

# Accessing `rowGraphs`/`colGraphs` and `rowData`/`colData` (a.k.a. 'getters')

To access graphs in `rowGraphs`/`colGraphs`, you can use one of the following
getter functions:

- `rowGraphs(x)`/`colGraphs(x)`: retrieves **all** (row/col)Graphs as a 
list of `igraph` objects.
- `rowGraph(x, i)`/`colGraph(x, i)`: retrieves only graph $i$ from the list. 
Note that $i$ can be a numeric scalar (index) or a character scalar (name).

The design here is equivalent to `assays()` versus `assay()` for 
`SummarizedExperiment` objects.

```{r getters}
# Get rowGraphs
rowGraphs(ge)

# Get colGraphs
colGraphs(ge)

# Get first rowGraph by index
rowGraph(ge, 1)

# Get first rowGraph by index (alternative)
rowGraphs(ge)[[1]]

# Get graph by name
rowGraph(ge, "gene_cor")
```

Careful readers will notice that this `igraph` object has node attributes that
were not present in the original graph: 'pathway' and 'coding'. This is 
because `rowGraphs()`/`rowGraph()` automatically extract `rowData` variables 
(if any) and add them to node attributes. `colGraphs()`/`colGraph()` work
in the same way (but with `colData`, of course). 
The same happens in the other direction: the `rowData()`/`colData()` methods 
for `GraphExperiment` objects automatically add node attributes (if any) to 
`rowData`/`colData`.

```{r rowdata_getter}
# `rowGraphs` and `rowData` are always in sync!
rowData(ge)

# `colGraphs` and `colData` too - yay!
colGraph(ge, 1) # note the `cell_type` attribute extracted from `colData`
```

Variables 'pathway' and 'coding' were in the original data frame we used as
`rowData`, but variable 'gene_cor__degree' was added by extracting the *degree*
attribute of nodes in rowGraph `gene_cor`.

# Modifying `GraphExperiment` objects (a.k.a. 'setters')

Like in the `SummarizedExperiment` and `SingleCellExperiment` classes,
all getter methods specific to `GraphExperiment` objects have a corresponding
setter method. Such methods allow users to modify elements by adding `<-`
after the getter method. For example, to add or replace a particular graph,
you would use the `rowGraph<-`/`colGraph<-` method as follows:

```{r graph_setter}
# Create a new rowGraph without correlations between -0.4 and 0.4
rg_filt <- rowGraph(ge, "gene_cor") |> 
    delete_vertex_attr("pathway") |>
    delete_vertex_attr("degree") |>
    delete_vertex_attr("coding")

todelete <- abs(E(rg_filt)$weight) <0.4
rg_filt <- delete_edges(rg_filt, which(todelete))
rg_filt

# Add filtered graph a new graph named `fcor`
rowGraph(ge, "filt_genecor") <- rg_filt
ge
```

If you'd like to replace all graphs at once, you could use the 
`rowGraphs<-`/`colGraphs<-` setters. For example, let's add a few graphs to 
the `GraphExperiment` object we created before by coercing 
from `SummarizedExperiment`:

```{r graphs_setter}
# Taking a quick look (note: nothing in `rowGraphs`/`colGraphs`)
ge1

# Adding graphs from `ge`
rowGraphs(ge1) <- rowGraphs(ge)
colGraphs(ge1) <- colGraphs(ge)
ge1
```

Lastly, you can also rename graphs by updating `rowGraphNames`/`colGraphNames` 
as follows:

```{r graphNames_setter}
# Rename graphs
rowGraphNames(ge1) <- c("correlations", "correlations_filtered_0.4")
colGraphNames(ge1) <- c("cell_correlations")
ge1
```

# Subsetting `GraphExperiment` objects

In `SummarizedExperiment` objects, subsetting rows and columns 
(using square brackets, `[`) automatically subsets `rowData` and `colData`
besides the assays. The same is true for `SingleCellExperiment` objects:
subsetting columns automatically subsets `colData` and `reducedDims`.

Since graphs in `GraphExperiment` objects are linked to rows and columns, 
subsetting rows of a `GraphExperiment` object automatically subsets rows of the
`assays`, `rowData`, and all graphs in `rowGraphs`, and subsetting
columns automatically subsets columns of the `assays`, `colData`, and
graphs in `colGraphs`. For example:

```{r subset}
# Subsetting `GraphExperiment` object
ge_subset <- ge[1:10, 1:10]

ge_subset
rowGraph(ge_subset, "gene_cor")
```

# Session information {.unnumbered}

This document was created under the following conditions:

```{r session_info}
sessioninfo::session_info()
```

# References {.unnumbered}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/GraphExperiment.R
\docType{class}
\name{GraphExperiment-class}
\alias{GraphExperiment-class}
\alias{GraphExperiment}
\title{\code{GraphExperiment} S4 class}
\usage{
GraphExperiment(..., rowGraphs = list(), colGraphs = list())
}
\arguments{
\item{...}{Arguments passed to the \code{SingleCellExperiment} constructor
function.}

\item{rowGraphs}{A list of \code{igraph} objects with one or multiple graphs
representing how features relate to each other. Node names (i.e.,
\code{V(graph)$name}) must match rownames of assays.}

\item{colGraphs}{A list of \code{igraph} objects with one or multiple graphs
representing how observations relate to each other. Node names (i.e.,
\code{V(graph)$name}) must match colnames of assays.}
}
\value{
A \code{GraphExperiment} object.
}
\description{
The \code{GraphExperiment} class was designed to represent rectangular,
quantitative data (e.g., from transcriptomics, proteomics, metabolomics)
along with graphs showing how features (e.g., genes, proteins, compounds)
and observations (e.g., samples, cells, species, spots) interact with each
other. It extends \code{SingleCellExperiment} by providing users with
additional slots where row/column graphs can be stored.
}
\details{
Like \code{SingleCellExperiment}, the \code{GraphExperiment} S4
class stores quantitative data with associated metadata (i.e.,
\code{rowData} and \code{colData}) along with embeddings from dimensionality
reduction techniques. However, it provides users with additional
containers for \code{igraph} objects containing graphs describing how
features and/or observations interact with each other. Graphs for features
are stored in a \code{rowGraphs} slot, and graphs for observations are
stored in a \code{colGraphs} slot. Both slots can hold one or
multiple \code{igraph} objects with some sort of network representation of
the features in \code{rownames} or observations in \code{colnames}. Example
graphs for features can be coexpression networks, regulatory networks,
or co-abundance networks. Example graphs for observations can be
cell-cell distances, sample-sample distances, or species networks
representing genealogies (as an alternative to phylogenies).

Importantly, node names in each row graph must match \code{rownames} of the
assays, and node names in each column graph must match \code{colnames} of
the assays. Besides, subsetting methods simultaneously subset \code{assays},
\code{rowData}, \code{rowGraphs}, \code{colData}, and \code{colGraphs}.

Besides the constructor function (\code{GraphExperiment()}), a
\code{GraphExperiment} object can also be created by coercing from a
\code{SummarizedExperiment} or
\code{SingleCellExperiment} object.
}
\examples{
# Example 1: from constructor function ----
## Simulate a matrix with 200 genes and 100 cells
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))

## Create a rowGraph from correlations (`igraph` object)
g <- graph_from_adjacency_matrix(cor(t(mat)), weighted = TRUE)

## Create a colGraph, also from correlations (but see scran::buildSNNGraph)
g2 <- graph_from_adjacency_matrix(cor(mat), weighted = TRUE)

## Construct `GraphExperiment` object
ge <- GraphExperiment(
    assays = list(counts = mat),
    rowGraphs = list(cor = g),
    colGraphs = list(cellcor = g2)
)
ge

# Example 2: From `SingleCellExperiment` object ----
sce <- SingleCellExperiment(assays = list(counts = mat))
ge <- as(sce, "GraphExperiment")
ge

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subset-methods.R
\name{GraphExperiment-subset}
\alias{GraphExperiment-subset}
\alias{[,GraphExperiment,ANY,ANY,ANY-method}
\title{Subsetting \code{GraphExperiment} objects}
\arguments{
\item{x}{A \code{\link{GraphExperiment}} object.}

\item{i}{Numeric, row indices for subsetting.}

\item{j}{Numeric, column indices for subsetting.}
}
\value{
a \code{\link{GraphExperiment}} object.
}
\description{
The subsetting method for \code{\link{GraphExperiment}} objects ensures
that nodes from \code{igraph} objects are filtered to match rows and columns
with the remainder of the object.
}
\section{subset}{

\describe{
\item{\code{[}:}{ subsetting method}
}
}

\examples{
# Simulate elements of a GraphExperiment object
## Assays
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))

## rowGraph (with node attributes)
g <- graph_from_adjacency_matrix(cor(t(mat)), weighted = TRUE)
V(g)$degree <- igraph::strength(g)

## colGraph
g2 <- graph_from_adjacency_matrix(cor(mat), weighted = TRUE)

## rowData
rdata <- data.frame(
    row.names = gene_ids, 
    pathway = sample(c("P1", "P2"), size = length(gene_ids), replace = TRUE),
    coding = sample(c(TRUE, FALSE), size = length(gene_ids), replace = TRUE)
)

## colData
cdata <- data.frame(
    row.names = cell_ids, 
    celltype = sample(c("ct1", "ct2"), size = length(cell_ids), replace = TRUE)
)


# Create a GraphExperiment object
ge <- GraphExperiment(
    assays = list(counts = mat), 
    rowData = rdata,
    colData = cdata,
    rowGraphs = list(cor = g),
    colGraphs = list(cellcor = g2)
)
ge

# Subset object
ge[1:5, 1:5]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coerce-methods.R
\name{GraphExperiment-coerce}
\alias{GraphExperiment-coerce}
\alias{coerce,SingleCellExperiment,GraphExperiment-method}
\alias{coerce,SummarizedExperiment,GraphExperiment-method}
\alias{coerce,RangedSummarizedExperiment,GraphExperiment-method}
\title{Coercion methods for \code{GraphExperiment} objects}
\arguments{
\item{from}{An object of class \code{SingleCellExperiment},
\code{SummarizedExperiment}, or \code{RangedSummarizedExperiment} to be
coerced to \code{GraphExperiment}.}
}
\value{
A \code{GraphExperiment} object.
}
\description{
The \code{GraphExperiment} class inherits from \code{SingleCellExperiment},
which in turn inherits from \code{(Ranged)SummarizedExperiment}. To ensure
\code{GraphExperiment} easily interoperates with these classes, we provide
users with traditional \code{as()} coercion methods.
}
\examples{
# Simulate a count matrix
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))

# Coerce from `SummarizedExperiment`
se <- SummarizedExperiment(assays = list(mat))
as(se, "GraphExperiment")

# Coerce from `RangedSummarizedExperiment`
rse <- as(se, "RangedSummarizedExperiment")
as(rse, "GraphExperiment")

# Coerce from `SingleCellExperiment`
sce <- as(se, "SingleCellExperiment")
as(sce, "GraphExperiment")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GraphExperiment-methods.R
\name{GraphExperiment-methods}
\alias{GraphExperiment-methods}
\alias{rowGraphs}
\alias{rowGraphs<-}
\alias{colGraphs}
\alias{colGraphs<-}
\alias{rowGraph}
\alias{rowGraph<-}
\alias{colGraph}
\alias{colGraph<-}
\alias{rowGraphNames}
\alias{rowGraphNames<-}
\alias{colGraphNames}
\alias{colGraphNames<-}
\alias{rowData}
\alias{colData}
\alias{rowData,GraphExperiment-method}
\alias{colData,GraphExperiment-method}
\alias{rowGraphs,GraphExperiment-method}
\alias{colGraphs,GraphExperiment-method}
\alias{rowGraph,GraphExperiment,missing-method}
\alias{rowGraph,GraphExperiment,ANY-method}
\alias{colGraph,GraphExperiment,missing-method}
\alias{colGraph,GraphExperiment,ANY-method}
\alias{rowGraphNames,GraphExperiment-method}
\alias{colGraphNames,GraphExperiment-method}
\alias{rowGraphs<-,GraphExperiment-method}
\alias{colGraphs<-,GraphExperiment-method}
\alias{rowGraph<-,GraphExperiment-method}
\alias{colGraph<-,GraphExperiment-method}
\alias{rowGraphNames<-,GraphExperiment,character-method}
\alias{colGraphNames<-,GraphExperiment,character-method}
\title{Methods for \code{GraphExperiment} objects}
\usage{
\S4method{rowData}{GraphExperiment}(x, use.names = TRUE, ...)

\S4method{colData}{GraphExperiment}(x, use.names = TRUE, ...)

\S4method{rowGraphs}{GraphExperiment}(x)

\S4method{colGraphs}{GraphExperiment}(x)

\S4method{rowGraph}{GraphExperiment,missing}(x, i)

\S4method{rowGraph}{GraphExperiment,ANY}(x, i)

\S4method{colGraph}{GraphExperiment,missing}(x, i)

\S4method{colGraph}{GraphExperiment,ANY}(x, i)

\S4method{rowGraphNames}{GraphExperiment}(x)

\S4method{colGraphNames}{GraphExperiment}(x)

\S4method{rowGraphs}{GraphExperiment}(x) <- value

\S4method{colGraphs}{GraphExperiment}(x) <- value

\S4method{rowGraph}{GraphExperiment}(x, i) <- value

\S4method{colGraph}{GraphExperiment}(x, i) <- value

\S4method{rowGraphNames}{GraphExperiment,character}(x) <- value

\S4method{colGraphNames}{GraphExperiment,character}(x) <- value
}
\arguments{
\item{x}{A \code{GraphExperiment} object.}

\item{use.names}{Passed to the \code{colData} method of
\code{SingleCellExperiment}. Default: TRUE.}

\item{...}{Ignored.}

\item{i}{List element (numeric for index, character for name) of the element
to access or replace.}

\item{value}{Replacement value for replacement methods.}
}
\value{
Return values depend on the method. See details and examples.
}
\description{
The \code{GraphExperiment} class provides users with methods to get and
set graphs (\code{igraph} objects) representing how features and observations
of \code{SingleCellExperiment} objects relate to each other.
}
\section{rowGraphs/colGraphs and rowGraph/colGraph methods}{

\describe{
\item{\code{rowGraphs(x)} and \code{colGraphs(x)}: }{
Getter for a \code{SimpleList} of \code{igraph} objects representing
rows and columns, respectively.}
\item{\code{rowGraphs(x) <- value} and \code{colGraphs(x) <- value}: }{
Setter for a SimpleList or list (coerced to SimpleList) of \code{igraph}
objects representing rows and columns, respectively.}
\item{\code{rowGraph(x, i)} and \code{colGraph(x, i)}: }{
Getter for an \code{igraph} object containing graph \code{i} from the list
stored in \code{rowGraphs} and \code{colGraphs}, respectively.}
\item{\code{rowGraph(x, i) <- value} and \code{colGraph(x, i) <- value}: }{
Setter for an \code{igraph} object to be stored in element \code{i} of
\code{rowGraphs} and \code{colGraphs}.}
}
}

\section{rowGraphNames and colGraphNames methods}{

\describe{
\item{\code{rowGraphNames(x)} and \code{colGraphNames(x)}: }{
Getter to extract names of graphs in \code{rowGraphs}
and \code{colGraphs}.}
\item{\code{rowGraphNames(x) <- value} and \code{colGraphNames(x) <- value}: }{
Setter to assign new names to the graphs stored in \code{rowGraphs}
and \code{colGraphs}.}
}
}

\section{rowData method}{

\describe{
\item{\code{rowData(x)}: }{
Getter to extract rowData (as in \code{SingleCellExperiment} objects),
but with node attributes of graphs included.}
}
}

\section{colData method}{

\describe{
\item{\code{colData(x)}: }{
Getter to extract colData (as in \code{SingleCellExperiment} objects),
but with node attributes of graphs included.}
}
}

\examples{
# Simulate elements of a GraphExperiment object
## Assays
gene_ids <- paste0("gene", seq_len(200))
cell_ids <- paste0("cell", seq_len(100))
mat <- matrix(rpois(20000, 5), ncol = 100, dimnames = list(gene_ids, cell_ids))

## rowGraph (with node attributes)
g <- graph_from_adjacency_matrix(cor(t(mat)), weighted = TRUE)
V(g)$degree <- igraph::strength(g)

## colGraph
g2 <- graph_from_adjacency_matrix(cor(mat), weighted = TRUE)

## rowData
rdata <- data.frame(
    row.names = gene_ids, 
    pathway = sample(c("P1", "P2"), size = length(gene_ids), replace = TRUE),
    coding = sample(c(TRUE, FALSE), size = length(gene_ids), replace = TRUE)
)

## colData
cdata <- data.frame(
    row.names = cell_ids, 
    celltype = sample(c("ct1", "ct2"), size = length(cell_ids), replace = TRUE)
)


# Create a GraphExperiment object
ge <- GraphExperiment(
    assays = list(counts = mat), 
    rowData = rdata,
    colData = cdata,
    rowGraphs = list(cor = g),
    colGraphs = list(cellcor = g2)
)
ge

# Extract graph names
rowGraphNames(ge)
colGraphNames(ge)


# Extract graphs
rowGraphs(ge)
rowGraph(ge, "cor")

colGraphs(ge)
colGraph(ge, "cellcor")


# Add a new graph
rowGraph(ge, "newcor") <- g
ge

# Add a list of graphs
colGraphs(ge) <- list(cellcor = g2, new_cellcor = g2)
ge

# Replace graph names
rowGraphNames(ge) <- c("network1", "network2")
ge

# Access rowData (note: rowData + node attributes combined)
rowData(ge)

# Access colData (note: colData + node attributes combined)
colData(ge)

}
